// 2006-04-30 programmeerimisvõistlus
// Ülesanne: MÜNDIPOKS
// Autor: Ahto Truu
// Testitud: GCC 3.2 / MinGW

// 2 ribaga laual mängib optimaalselt
// 3 ja 4 riba korral tunneb ära mõned võiduseisud
// muudel juhtudel teeb juhusliku käigu

#include <iostream>
#include <cstdlib>
#include <cassert>
using namespace std;

int r; // ribade arv laual
int b[4]; // mitu vaba kohta on meie mündi taga
int f[4]; // mitu vaba kohta on meie mündi ees

// väljastab jooksva seisu, silumiseks
void dump() {
    for (int i = 0; i < r; ++i)
        cerr << " " << b[i] << "." << f[i];
    cerr << endl;
}

// kas mäng on läbi?
bool done() {
    for (int i = 0; i < r; ++i)
        if (b[i] + f[i] > 0)
            return false;
    return true;
}

// teeb juhusliku käigu
void random(int & i, int & k) {
    int x = 0;
    for (i = 0; i < r; ++i)
        x += b[i] + f[i];
    x = rand() % x;
    for (i = 0; i < r; ++i) {
        if (x < b[i]) {
            k = x - b[i];
            return;
        }
        x -= b[i];
        if (x < f[i]) {
            k = f[i] - x;
            return;
        }
        x -= f[i];
    }
    assert(false);
}

// 2 ribaga mängu strateegia
void play2(int & i, int & k) {
    for (int j = 0; j < 2; ++j)
        if (f[j] > f[(j + 1) % 2]) {
            i = j; k = f[j] - f[(j + 1) % 2];
            return;
        }
    // kaotusseis, teeme juhusliku käigu
    random(i, k);
}

// 3 ribaga mängu strateegia
void play3(int & i, int & k) {
    for (int j = 0; j < 3; ++j)
        if (f[j] == f[(j + 1) % 3])
            if (f[(j + 2) % 3] > 0) {
                i = (j + 2) % 3; k = f[(j + 2) % 3];
                return;
            }
    // muudel juhtudel teeme juhusliku käigu
    random(i, k);
}

// 4 ribaga mängu strateegia
void play4(int & i, int & k) {
    for (int j = 0; j < 4; ++j)
        if (f[j] == f[(j + 1) % 4]) {
            if (f[(j + 2) % 4] > f[(j + 3) % 4]) {
                i = (j + 2) % 4; k = f[(j + 2) % 4] - f[(j + 3) % 4];
                return;
            }
            if (f[(j + 3) % 4] > f[(j + 2) % 4]) {
                i = (j + 3) % 4; k = f[(j + 3) % 4] - f[(j + 2) % 4];
                return;
            }
        }
    for (int j = 0; j < 2; ++j)
        if (f[j] == f[(j + 2) % 4]) {
            if (f[(j + 1) % 4] > f[(j + 3) % 4]) {
                i = (j + 1) % 4; k = f[(j + 1) % 4] - f[(j + 3) % 4];
                return;
            }
            if (f[(j + 3) % 4] > f[(j + 1) % 4]) {
                i = (j + 3) % 4; k = f[(j + 3) % 4] - f[(j + 1) % 4];
                return;
            }
        }
    // muudel juhtudel teeme juhusliku käigu
    random(i, k);
}

int main() {
    int p, i, k;
    cin >> r;
    for (i = 0; i < r; ++i) {
        cin >> k;
        b[i] = 0; f[i] = k - 2;
    }
    cin >> p;
    while (true) {
        if (p == 1) {
            if (done()) {
                cout << "0 0" << endl;
                break;
            }
            if (r == 2) play2(i, k);
            if (r == 3) play3(i, k);
            if (r == 4) play4(i, k);
            f[i] -= k; b[i] += k;
            cout << i + 1 << " " << k << endl;
        }
        cin >> i >> k;
        if (i == 0 && k == 0)
            break;
        f[i - 1] -= k;
        p = 1;
    }
    return 0;
}
