// 2006-04-30 programmeerimisvõistlus
// Ülesanne: MÜNDIPOKS
// Autor: Ahto Truu
// Testitud: GCC 3.2 / MinGW

// mängib optimaalselt NIM-summade abil

#include <iostream>
#include <cstdlib>
#include <cassert>
using namespace std;

int r; // ribade arv laual
int b[4]; // mitu vaba kohta on meie mündi taga
int f[4]; // mitu vaba kohta on meie mündi ees

// väljastab jooksva seisu, silumiseks
void dump() {
    for (int i = 0; i < r; ++i)
        cerr << " " << b[i] << "." << f[i];
    cerr << endl;
}

// arvutab antud käigu NIM-summa
int nimsum(int i, int k) {
    f[i] -= k;
    int s = 0;
    for (int j = 0; j < r; ++j)
        s ^= f[j];
    f[i] += k;
    return s;
}

// leiab järgmise käigu
bool play(int & i, int & k) {
    // otsime võidukäiku
    for (i = 0; i < r; ++i)
        for (k = f[i]; k > 0; --k)
            if (nimsum(i, k) == 0)
                return true;
    // loendame võimalikud käigud
    int x = 0;
    for (i = 0; i < r; ++i)
        x += b[i] + f[i];
    // kui üldse käiku pole, on mäng läbi
    if (x == 0)
        return false;
    // muidu teeme juhusliku käigu
    x = rand() % x;
    for (i = 0; i < r; ++i) {
        if (x < b[i]) {
            k = x - b[i];
            return true;
        }
        x -= b[i];
        if (x < f[i]) {
            k = f[i] - x;
            return true;
        }
        x -= f[i];
    }
    assert(false);
}

int main() {
    int p, i, k;
    cin >> r;
    for (i = 0; i < r; ++i) {
        cin >> k;
        b[i] = 0; f[i] = k - 2;
    }
    cin >> p;
    while (true) {
        if (p == 1) {
            if (!play(i, k)) {
                cout << "0 0" << endl;
                break;
            }
            f[i] -= k; b[i] += k;
            cout << i + 1 << " " << k << endl;
        }
        cin >> i >> k;
        if (i == 0 && k == 0)
            break;
        f[i - 1] -= k;
        p = 1;
    }
    return 0;
}
