{ 2006-04-30 programmeerimisvõistlus                                        }
{ Ülesanne: ROTT                                                            }
{ Autor: Kristo Tammeoja                                                    }
{ Testitud: FPC 2.0.0 / Win32                                               }

const
    SIS_FAIL = 'rott.sis';
    VAL_FAIL = 'rott.val';
    MAX_MN = 30; // maksimaalne labürindi küljepikkus

    // labürindi legend
    LAB_TYHI = '0';
    LAB_SEIN = 'X';

var
    sfail, vfail : text; // sisend- ja väljundfail

    // labürindi mõõtmed ja kirjeldus
    m, n : integer;
    labyrint : array[0..MAX_MN+1, 0..MAX_MN+1] of char;

    // iga lahtri juurest teede arv juustutükini
    teid : array[1..MAX_MN, 1..MAX_MN] of longint;
    on_arvutatud : array[1..MAX_MN, 1..MAX_MN] of boolean;

    // vastus
    nr : longint;              // sisendina saadud arv...
    vastus : string[2*MAX_MN]; // ...ja sellele vastav tee

    i, j : integer;

procedure init_leia_teid;
var i, j : integer;
begin
    // esmalt nullime koik loendurid
    for i := 1 to m do
        for j := 1 to n do
            on_arvutatud[i, j] := false;
    // juustutüki juurest on üks tee olemas (paigal seista ;)
    teid[m, n] := 1;
    on_arvutatud[m, n] := true;
end;

function leia_teid(i, j : integer; max_required : longint) : longint;
begin
    if labyrint[i, j] = LAB_SEIN then begin
        leia_teid := 0;
        exit;
    end;

    if on_arvutatud[i, j] then begin
        leia_teid := teid[i, j];
        exit;
    end;

    // kui pole veel arvutatud

    teid[i, j] := 0;
    // kui on voimalik paremale liikuda
    if labyrint[i, j+1] = LAB_TYHI then
        teid[i, j] := teid[i, j] + leia_teid(i, j+1, max_required);
    // kui on voimalik alla liikuda
    if (labyrint[i+1, j] = LAB_TYHI) and (teid[i, j] < max_required) then
        teid[i, j] := teid[i, j] + leia_teid(i+1, j, max_required - teid[i, j]);

    on_arvutatud[i, j] := true;

    // vastus
    leia_teid := teid[i, j];
end; // leia_teid

begin
    // ----- avame failid -----
    assign(sfail, SIS_FAIL); reset(sfail);
    assign(vfail, VAL_FAIL); rewrite(vfail);

    // ----- loeme labürindi andmed -----
    // mõõtmed
    readln(sfail, m, n);
    // servad
    for i := 0 to m+1 do begin
        labyrint[i, 0] := LAB_SEIN;
        labyrint[i, n+1] := LAB_SEIN;
    end;
    for j := 0 to n+1 do begin
        labyrint[0, j] := LAB_SEIN;
        labyrint[m+1, j] := LAB_SEIN;
    end;
    // labürint ise
    for i := 1 to m do begin
        for j := 1 to n do begin
            read(sfail, labyrint[i, j]);
            if (labyrint[i, j] <> LAB_TYHI) and (labyrint[i, j] <> LAB_SEIN) then begin
                writeln('viga labürindi kirjelduses lahtris (', i, ', ', j, ')');
                halt(1);
            end;
        end;
        readln(sfail);
    end;

    // ----- ülesanne -----
    // loeme tee numbri
    readln(sfail, nr);
    vastus := '';

    // ----- algväärtustame teede arvu leidmise -----
    init_leia_teid;

    // ----- ülesande lahendamine -----
    // kõigepealt läheme esimesele ruudule
    i := 1;
    j := 1;
    // kuni pole veel lõppu jõudnud
    while not ((i=m) and (j=n)) do begin
        // paremale minevad teed on tähestikus eespool
        // kui neid on piisavalt palju...
        if (labyrint[i, j+1] = LAB_TYHI) and (leia_teid(i, j+1, nr) >= nr) then begin
            // liigume paremale
            vastus := vastus + 'E';
            j := j+1;
        end else if labyrint[i+1, j] = LAB_TYHI then begin
            // liigume alla
            vastus := vastus + 'S';
            nr := nr - leia_teid(i, j+1, nr);
            i := i+1;
        end else begin
            // sellise numbriga teed pole olemas
            break;
        end;
    end; // while

    // kontrollime, kas üldse on nii palju teid olemas
    if nr <> 1 then begin
        writeln('sellise numbriga teed pole olemas');
        halt(1);
    end;

    // ----- vastus -----
    writeln(vfail, vastus);

    // ----- sulgeme failid -----
    close(sfail);
    close(vfail);
end.
